Zum Hauptinhalt springen

Integration mit Vue

Tipp

Machen Sie sich mit den grundlegenden Konzepten und Mustern von Vue vertraut, bevor Sie diese Dokumentation lesen. Zur Auffrischung Ihres Wissens lesen Sie die Vue-3-Dokumentation.

DHTMLX To Do List ist mit Vue 3 kompatibel. Die folgenden Beispiele zeigen, wie Sie beide zusammen verwenden. Ein vollständiges Projekt finden Sie im Beispiel auf GitHub.

Projekt erstellen

Erstellen Sie ein neues Vue-Projekt und installieren Sie die Abhängigkeiten.

Info

Bevor Sie ein neues Projekt erstellen, installieren Sie Node.js.

Um ein Vue-Projekt zu erstellen, führen Sie folgenden Befehl aus:

npm create vue@latest

Der Befehl installiert und führt create-vue aus, das offizielle Projektgerüst-Werkzeug für Vue. Weitere Details finden Sie im Vue.js Quick Start.

Benennen Sie das Projekt my-vue-todo-app.

Abhängigkeiten installieren

Wechseln Sie in das App-Verzeichnis:

cd my-vue-todo-app

Installieren Sie die Abhängigkeiten und starten Sie den Entwicklungsserver mit einem Paketmanager.

Führen Sie folgende Befehle mit yarn aus:

yarn
yarn start

Führen Sie folgende Befehle mit npm aus:

npm install
npm run dev

Die App läuft unter einer Localhost-Adresse (z. B. http://localhost:3000).

To-Do-Liste erstellen

Stoppen Sie die App und installieren Sie das To-Do-List-Paket.

Schritt 1. Paket installieren

Laden Sie das To-Do-List-Testpaket herunter und folgen Sie den Anweisungen in der README-Datei. Die Testversion ist nur 30 Tage lang verfügbar.

Schritt 2. Komponente erstellen

Erstellen Sie eine Vue-Komponente, um die To-Do-Liste mit der Toolbar in die Anwendung einzubinden. Fügen Sie im Verzeichnis src/components/ eine neue Datei namens ToDo.vue hinzu.

Quelldateien importieren

Öffnen Sie ToDo.vue und importieren Sie die Quelldateien der To-Do-Liste. Wählen Sie einen der beiden Importpfade:

  • PRO-Version aus einem lokalen Ordner installiert - Import aus dhx-todolist-package
  • Testversion - Import aus @dhx/trial-todolist

Das folgende Beispiel importiert aus dem PRO-Paket:

ToDo.vue
<script>
import { ToDo, Toolbar } from 'dhx-todolist-package';
import 'dhx-todolist-package/dist/todo.css';
</script>

Je nach Paket können die Quelldateien minifiziert sein. Importieren Sie die CSS-Datei in diesem Fall als todo.min.css.

Das folgende Snippet importiert aus dem Testpaket:

ToDo.vue
<script>
import { ToDo, Toolbar } from '@dhx/trial-todolist';
import '@dhx/trial-todolist/dist/todo.css';
</script>

Dieses Tutorial verwendet die Testversion.

Container festlegen und To-Do-Liste mit Toolbar hinzufügen

Um die To-Do-Liste mit der Toolbar auf der Seite anzuzeigen, erstellen Sie Container für beide Komponenten und initialisieren Sie diese mit den Konstruktoren. Das folgende Beispiel initialisiert die Komponenten innerhalb des mounted()-Hooks:

ToDo.vue
<script>
import { ToDo, Toolbar } from "@dhx/trial-todolist";
import "@dhx/trial-todolist/dist/todo.css";

export default {
mounted() {
// To-Do-List-Komponente initialisieren
this.todo = new ToDo(this.$refs.todo_container, {});

// Toolbar-Komponente initialisieren
this.toolbar = new Toolbar(this.$refs.toolbar_container, {
api: this.todo.api, // innere API der To-Do-Liste bereitstellen
// weitere Konfigurationseigenschaften
});
},

unmounted() {
this.todo.destructor(); // To-Do-Liste zerstören
this.toolbar.destructor(); // Toolbar zerstören
}
};
</script>

<template>
<div class="component_container">
<div ref="toolbar_container"></div>
<div ref="todo_container" style="height: calc(100% - 56px);"></div>
</div>
</template>

Daten laden

Erstellen Sie die Datei data.js im Verzeichnis src/ und fügen Sie Daten hinzu. Das folgende Beispiel exportiert eine getData()-Funktion, die Aufgaben, Benutzer und Projekte zurückgibt:

data.js
export function getData() {
const tasks = [
{
id: "temp://1652991560212",
project: "introduction",
text: "Greetings, everyone! \u{1F44B} \nI'm DHTMLX To Do List.",
priority: 1
},
{
id: "1652374122964",
project: "introduction",
text: "You can assign task performers and due dates using the menu.",
assigned: ["user_4", "user_1", "user_2", "user_3"],
due_date: "2033-03-08T21:00:00.000Z",
priority: 2
},
// ...
];
const users = [
{
id: "user_1",
label: "Don Smith",
avatar:
"https://snippet.dhtmlx.com/codebase/data/common/img/02/avatar_61.jpg"
},
// ...
];
const projects = [
{
id: "introduction",
label: "Introduction to DHTMLX To Do List"
},
{
id: "widgets",
label: "Our widgets"
}
];
return { tasks, users, projects };
}

Öffnen Sie App.vue, importieren Sie die Daten und initialisieren Sie diese über die interne data()-Methode. Übergeben Sie die Daten als Props an die <ToDo/>-Komponente:

App.vue
<script>
import ToDo from "./components/ToDo.vue";
import { getData } from "./data";

export default {
components: { ToDo },
data() {
const { users, projects, tasks } = getData();
return {
users,
projects,
tasks
};
}
};
</script>

<template>
<ToDo :users="users" :tasks="tasks" :projects="projects" />
</template>

Öffnen Sie ToDo.vue und wenden Sie die übergebenen Props auf das Konfigurationsobjekt der To-Do-Liste an. Das folgende Snippet übergibt Benutzer-, Aufgaben- und Projektdaten über die Konfiguration:

ToDo.vue
<script>
import { ToDo, Toolbar } from "@dhx/trial-todolist";
import "@dhx/trial-todolist/dist/todo.css";

export default {
props: ["tasks", "users", "projects"],

mounted() {
this.todo = new ToDo(this.$refs.todo_container, {
users: this.users,
tasks: this.tasks,
projects: this.projects,
// weitere Konfigurationseigenschaften
});

this.toolbar = new Toolbar(this.$refs.toolbar_container, {
api: this.todo.api,
// weitere Konfigurationseigenschaften
});
},

unmounted() {
this.todo.destructor();
this.toolbar.destructor();
}
};
</script>

<template>
<div class="component_container">
<div ref="toolbar_container"></div>
<div ref="todo_container" style="height: calc(100% - 56px);"></div>
</div>
</template>

Sie können auch die Methode parse() innerhalb von mounted() verwenden, um Daten in die To-Do-Liste zu laden. Das folgende Beispiel lädt Daten nach der Initialisierung mit parse():

ToDo.vue
<script>
import { ToDo, Toolbar } from "@dhx/trial-todolist";
import "@dhx/trial-todolist/dist/todo.css";

export default {
props: ["tasks", "users", "projects"],

mounted() {
this.todo = new ToDo(this.$refs.todo_container, {});

this.toolbar = new Toolbar(this.$refs.toolbar_container, {
api: this.todo.api,
// weitere Konfigurationseigenschaften
});

this.todo.parse({
users: this.users,
tasks: this.tasks,
projects: this.projects
});
},

unmounted() {
this.todo.destructor();
this.toolbar.destructor();
}
};
</script>

<template>
<div class="component_container">
<div ref="toolbar_container"></div>
<div ref="todo_container" style="height: calc(100% - 56px);"></div>
</div>
</template>

Jeder Aufruf von parse(data) ersetzt den aktuellen Datensatz.

Die Komponente rendert jetzt eine befüllte To-Do-Liste. Weitere verfügbare Eigenschaften finden Sie in der Konfigurationsübersicht.

Events verarbeiten

Abonnieren Sie Events, um auf Benutzeraktionen zu reagieren. Siehe die vollständige Event-Liste.

Öffnen Sie ToDo.vue und vervollständigen Sie die Methode mounted(). Das folgende Snippet registriert einen Handler für das add-task-Event:

ToDo.vue
<script>
// ...
export default {
// ...
mounted() {
this.todo = new ToDo(this.$refs.todo_container, {});

this.todo.api.on("add-task", ({ id }) => {
console.log("A new task is added", id);
});
},

unmounted() {
this.todo.destructor();
}
}
</script>

// ...

Schritt 3. To-Do-Liste in die App einbinden

Um die Komponente in die App einzubinden, öffnen Sie App.vue und ersetzen Sie den Standard-Code durch das folgende Snippet:

App.vue
<script>
import ToDo from "./components/ToDo.vue";
import { getData } from "./data";

export default {
components: { ToDo },
data() {
const { users, projects, tasks } = getData();
return {
users,
projects,
tasks
};
}
};
</script>

<template>
<ToDo :users="users" :tasks="tasks" :projects="projects" />
</template>

Starten Sie die App. Die To-Do-Liste wird mit Beispieldaten gerendert:

In einer Vue-Anwendung gerendertes DHTMLX To Do List mit Beispieldaten

Das vollständige Projekt finden Sie auf GitHub.

Zum Hauptinhalt springen

Integration mit Angular

Tipp

Machen Sie sich mit den grundlegenden Konzepten und Mustern von Angular vertraut, bevor Sie diese Dokumentation lesen. Zur Auffrischung Ihres Wissens lesen Sie die Angular-Dokumentation.

DHTMLX To Do List ist mit Angular kompatibel. Die folgenden Beispiele zeigen, wie Sie beide zusammen verwenden. Ein vollständiges Projekt finden Sie im Beispiel auf GitHub.

Projekt erstellen

Erstellen Sie ein neues Angular-Projekt und installieren Sie die Abhängigkeiten.

Info

Bevor Sie ein neues Projekt erstellen, installieren Sie die Angular CLI und Node.js.

Erstellen Sie mit Angular CLI ein neues Projekt namens my-angular-todo-app. Führen Sie folgenden Befehl aus:

ng new my-angular-todo-app
Hinweis

Deaktivieren Sie für diesen Leitfaden Server-Side Rendering (SSR) und Static Site Generation (SSG/Prerendering) beim Erstellen der neuen Angular-App.

Der Befehl installiert alle benötigten Werkzeuge.

Abhängigkeiten installieren

Wechseln Sie in das neu erstellte App-Verzeichnis:

cd my-angular-todo-app

Installieren Sie die Abhängigkeiten und starten Sie den Entwicklungsserver mit dem Paketmanager yarn:

yarn
yarn start

Die App läuft unter einer Localhost-Adresse (z. B. http://localhost:3000).

To-Do-Liste erstellen

Stoppen Sie die App und installieren Sie das To-Do-List-Paket.

Schritt 1. Paket installieren

Laden Sie das To-Do-List-Testpaket herunter und folgen Sie den Anweisungen in der README-Datei. Die Testversion ist nur 30 Tage lang verfügbar.

Schritt 2. Komponente erstellen

Erstellen Sie eine Angular-Komponente, um die To-Do-Liste mit der Toolbar in die Anwendung einzubinden. Fügen Sie im Verzeichnis src/app/ den Ordner todo hinzu und erstellen Sie darin die Datei todo.component.ts.

Quelldateien importieren

Öffnen Sie todo.component.ts und importieren Sie die Quelldateien der To-Do-Liste. Wählen Sie einen der beiden Importpfade:

  • PRO-Version aus einem lokalen Ordner installiert - Import aus dhx-todolist-package
  • Testversion - Import aus @dhx/trial-todolist

Das folgende Snippet importiert aus dem PRO-Paket:

todo.components.ts
import { ToDo, Toolbar } from 'dhx-todolist-package';

Das folgende Snippet importiert aus dem Testpaket:

todo.components.ts
import { ToDo, Toolbar } from '@dhx/trial-todolist';

Dieses Tutorial verwendet die Testversion.

Container festlegen und To-Do-Liste mit Toolbar initialisieren

Um die To-Do-Liste mit der Toolbar auf der Seite anzuzeigen, legen Sie Container für beide Komponenten fest und initialisieren Sie diese mit den Konstruktoren. Das folgende Beispiel definiert das Template, referenziert die Container und initialisiert die Komponenten innerhalb von ngOnInit():

todo.component.ts
import { ToDo, Toolbar } from '@dhx/trial-todolist'; 
import { Component, ElementRef, OnInit, ViewChild, OnDestroy, ViewEncapsulation} from '@angular/core';

@Component({
encapsulation: ViewEncapsulation.None,
selector: "todo", // Template-Name, der in "app.component.ts" als <todo /> verwendet wird
styleUrls: ["./todo.component.css"], // CSS-Datei einbinden

template: `<main class = "component_container">
<div #toolbar_container></div>
<div #todo_container class = "widget"></div>
</main>`
})

export class ToDoComponent implements OnInit, OnDestroy {
// Container für Toolbar initialisieren
@ViewChild("toolbar_container", { static: true }) toolbar_container!: ElementRef;
// Container für To-Do-Liste initialisieren
@ViewChild("todo_container", { static: true }) todo_container!: ElementRef;

private _todo!: ToDo;
private _toolbar!: Toolbar;

ngOnInit() {
// To-Do-List-Komponente initialisieren
this._todo = new ToDo(this.todo_container.nativeElement, {});

// Toolbar-Komponente initialisieren
this._toolbar = new Toolbar(this.toolbar_container.nativeElement, {
api: this._todo.api,
// weitere Konfigurationseigenschaften
});
}

ngOnDestroy(): void {
this._todo.destructor(); // To-Do-Liste zerstören
this._toolbar.destructor(); // Toolbar zerstören
}
}

Styles hinzufügen

Importieren Sie die CSS-Datei, damit die To-Do-Liste korrekt dargestellt wird. Erstellen Sie die Datei todo.component.css im Verzeichnis src/app/todo/ und fügen Sie die Styles für die To-Do-Liste und den Container hinzu. Das folgende Snippet importiert die To-Do-List-Styles und legt die Layout-Abmessungen fest:

todo.component.css
/* To-Do-List-Styles importieren */
@import "@dhx/trial-todolist/dist/todo.css";

/* Styles für die Ausgangsseite */
html,
body{
height: 100%;
padding: 0;
margin: 0;
background-color: #f7f7f7;
}

/* Styles für den To-Do-List- und Toolbar-Container */
.component_container {
height: 100%;
max-width: 800px;
margin: 0 auto;
}

/* Styles für den To-Do-List-Container */
.widget {
height: calc(100% - 56px);
}

Daten laden

Erstellen Sie die Datei data.ts im Verzeichnis src/app/todo/ und fügen Sie Daten hinzu. Das folgende Beispiel exportiert eine getData()-Funktion, die Aufgaben, Benutzer und Projekte zurückgibt:

data.ts
export function getData() {
const tasks = [
{
id: "temp://1652991560212",
project: "introduction",
text: "Greetings, everyone! \u{1F44B} \nI'm DHTMLX To Do List.",
priority: 1
},
{
id: "1652374122964",
project: "introduction",
text: "You can assign task performers and due dates using the menu.",
assigned: ["user_4", "user_1", "user_2", "user_3"],
due_date: "2033-03-08T21:00:00.000Z",
priority: 2
},
// ...
];
const users = [
{
id: "user_1",
label: "Don Smith",
avatar:
"https://snippet.dhtmlx.com/codebase/data/common/img/02/avatar_61.jpg"
},
// ...
];
const projects = [
{
id: "introduction",
label: "Introduction to DHTMLX To Do List"
},
{
id: "widgets",
label: "Our widgets"
}
];
return { tasks, users, projects };
}

Öffnen Sie todo.component.ts. Importieren Sie die Datendatei und übergeben Sie die Dateneigenschaften an das Konfigurationsobjekt der To-Do-Liste innerhalb der Methode ngOnInit(). Das folgende Snippet wendet Benutzer-, Aufgaben- und Projektdaten bei der Initialisierung an:

todo.component.ts
import { ToDo, Toolbar } from '@dhx/trial-todolist';
import { getData } from "./data"; // Daten importieren
import { Component, ElementRef, OnInit, ViewChild, OnDestroy, ViewEncapsulation} from '@angular/core';

@Component({
encapsulation: ViewEncapsulation.None,
selector: "todo",
styleUrls: ["./todo.component.css"],
template: `<main class = "component_container">
<div #toolbar_container></div>
<div #todo_container class = "widget"></div>
</main>`
})

export class ToDoComponent implements OnInit, OnDestroy {
@ViewChild("toolbar_container", { static: true }) toolbar_container!: ElementRef;
@ViewChild("todo_container", { static: true }) todo_container!: ElementRef;

private _todo!: ToDo;
private _toolbar!: Toolbar;

ngOnInit() {
const { users, tasks, projects } = getData(); // Dateneigenschaften initialisieren
this._todo = new ToDo(this.todo_container.nativeElement, {
users,
tasks,
projects,
// weitere Konfigurationseigenschaften
});

this._toolbar = new Toolbar(this.toolbar_container.nativeElement, {
api: this._todo.api,
// weitere Konfigurationseigenschaften
});
}

ngOnDestroy(): void {
this._todo.destructor();
this._toolbar.destructor();
}
}

Sie können auch die Methode parse() innerhalb von ngOnInit() verwenden, um Daten in die To-Do-Liste zu laden. Das folgende Beispiel lädt Daten nach der Initialisierung mit parse():

todo.component.ts
import { ToDo, Toolbar } from '@dhx/trial-todolist';
import { getData } from "./data"; // Daten importieren
import { Component, ElementRef, OnInit, ViewChild, OnDestroy, ViewEncapsulation} from '@angular/core';

@Component({
encapsulation: ViewEncapsulation.None,
selector: "todo",
styleUrls: ["./todo.component.css"],
template: `<main class = "component_container">
<div #toolbar_container></div>
<div #todo_container class = "widget"></div>
</main>`
})

export class ToDoComponent implements OnInit, OnDestroy {
@ViewChild("toolbar_container", { static: true }) toolbar_container!: ElementRef;
@ViewChild("todo_container", { static: true }) todo_container!: ElementRef;

private _todo!: ToDo;
private _toolbar!: Toolbar;

ngOnInit() {
const { users, tasks, projects } = getData(); // Dateneigenschaften initialisieren
this._todo = new ToDo(this.todo_container.nativeElement, {});

this._toolbar = new Toolbar(this.toolbar_container.nativeElement, {
api: this._todo.api,
// weitere Konfigurationseigenschaften
});

// Daten über die parse()-Methode anwenden
this._todo.parse({
users,
tasks,
projects
});
}

ngOnDestroy(): void {
this._todo.destructor();
this._toolbar.destructor();
}
}

Jeder Aufruf von parse(data) ersetzt den aktuellen Datensatz.

Die Komponente rendert jetzt eine befüllte To-Do-Liste. Weitere verfügbare Eigenschaften finden Sie in der Konfigurationsübersicht.

Events verarbeiten

Abonnieren Sie Events, um auf Benutzeraktionen zu reagieren. Siehe die vollständige Event-Liste.

Öffnen Sie todo.component.ts und vervollständigen Sie die Methode ngOnInit(). Das folgende Snippet registriert einen Handler für das add-task-Event:

todo.component.ts
// ...
ngOnInit() {
this._todo = new ToDo(this.todo_container.nativeElement, {});

this._todo.events.on("add-task", (obj) => {
console.log("A new task is added", obj);
});
}

ngOnDestroy(): void {
this._todo.destructor();
}

Schritt 3. To-Do-Liste in die App einbinden

Um die ToDoComponent in die App einzubinden, öffnen Sie src/app/app.component.ts und ersetzen Sie den Standard-Code durch das folgende Snippet:

app.component.ts
import { Component } from "@angular/core";

@Component({
selector: "app-root",
template: `<todo/>` // Template aus "todo.component.ts" erstellt
})
export class AppComponent {
name = "";
}

Erstellen Sie die Datei app.module.ts im Verzeichnis src/app/ und registrieren Sie die ToDoComponent. Das folgende Beispiel deklariert die Komponenten und bootet die App:

app.module.ts
import { NgModule } from "@angular/core";
import { BrowserModule } from "@angular/platform-browser";

import { AppComponent } from "./app.component";
import { ToDoComponent } from "./todo/todo.component";

@NgModule({
declarations: [AppComponent, ToDoComponent],
imports: [BrowserModule],
bootstrap: [AppComponent]
})
export class AppModule {}

Im letzten Schritt öffnen Sie src/main.ts und ersetzen den vorhandenen Code durch folgenden:

main.ts
import { platformBrowserDynamic } from "@angular/platform-browser-dynamic";
import { AppModule } from "./app/app.module";
platformBrowserDynamic()
.bootstrapModule(AppModule)
.catch((err) => console.error(err));

Starten Sie die App. Die To-Do-Liste wird mit Beispieldaten gerendert:

In einer Angular-Anwendung gerendertes DHTMLX To Do List mit Beispieldaten

Das vollständige Projekt finden Sie auf GitHub.

Zum Hauptinhalt springen

Integration mit React

Tipp

Machen Sie sich mit den grundlegenden Konzepten und Mustern von React vertraut, bevor Sie diese Dokumentation lesen. Zur Auffrischung Ihres Wissens lesen Sie die React-Dokumentation.

DHTMLX To Do List ist mit React kompatibel. Die folgenden Beispiele zeigen, wie Sie beide zusammen verwenden. Ein vollständiges Projekt finden Sie im Beispiel auf GitHub.

Projekt erstellen

Erstellen Sie ein neues React-Projekt und installieren Sie die Abhängigkeiten.

Info

Bevor Sie ein neues Projekt erstellen, installieren Sie Vite (optional) und Node.js.

Erstellen Sie ein einfaches React-Projekt oder verwenden Sie React mit Vite. Das folgende Beispiel benennt das Projekt my-react-todo-app:

npx create-react-app my-react-todo-app

Abhängigkeiten installieren

Wechseln Sie in das neu erstellte App-Verzeichnis:

cd my-react-todo-app

Installieren Sie die Abhängigkeiten und starten Sie den Entwicklungsserver mit einem Paketmanager.

Führen Sie folgende Befehle mit yarn aus:

yarn
yarn start

Führen Sie folgende Befehle mit npm aus:

npm install
npm start

Die App läuft unter einer Localhost-Adresse (z. B. http://localhost:3000).

To-Do-Liste erstellen

Stoppen Sie die App und installieren Sie das To-Do-List-Paket.

Schritt 1. Paket installieren

Laden Sie das To-Do-List-Testpaket herunter und folgen Sie den Anweisungen in der README-Datei. Die Testversion ist nur 30 Tage lang verfügbar.

Schritt 2. Komponente erstellen

Erstellen Sie eine React-Komponente, um die To-Do-Liste mit der Toolbar in die Anwendung einzubinden. Fügen Sie im Verzeichnis src/ eine neue Datei namens ToDo.jsx hinzu.

Quelldateien importieren

Öffnen Sie ToDo.jsx und importieren Sie die Quelldateien der To-Do-Liste. Wählen Sie einen der beiden Importpfade:

  • PRO-Version aus einem lokalen Ordner installiert - Import aus dhx-todolist-package
  • Testversion - Import aus @dhx/trial-todolist

Das folgende Beispiel importiert aus dem PRO-Paket:

ToDo.jsx
import { ToDo, Toolbar } from 'dhx-todolist-package';
import 'dhx-todolist-package/dist/todo.css';

Je nach Paket können die Quelldateien minifiziert sein. Importieren Sie die CSS-Datei in diesem Fall als todo.min.css.

Das folgende Snippet importiert aus dem Testpaket:

ToDo.jsx
import { ToDo, Toolbar } from '@dhx/trial-todolist';
import "@dhx/trial-todolist/dist/todo.css";

Dieses Tutorial verwendet die Testversion.

Container festlegen und To-Do-Liste mit Toolbar hinzufügen

Um die To-Do-Liste mit der Toolbar auf der Seite anzuzeigen, erstellen Sie Container für beide Komponenten und initialisieren Sie diese mit den Konstruktoren. Das folgende Beispiel rendert beide Container und initialisiert die Komponenten innerhalb von useEffect:

ToDo.jsx
import { useEffect, useRef } from "react";
import { ToDo, Toolbar } from "@dhx/trial-todolist";
import "@dhx/trial-todolist/dist/todo.css"; // To-Do-List-Styles einbinden

export default function ToDoComponent(props) {
let toolbar_container = useRef(); // Container für Toolbar initialisieren
let todo_container = useRef(); // Container für To-Do-Liste initialisieren

useEffect(() => {
// To-Do-List-Komponente initialisieren
const todo = new ToDo(todo_container.current, {});

// Toolbar-Komponente initialisieren
const toolbar = new Toolbar(toolbar_container.current, {
api: todo.api, // innere API der To-Do-Liste bereitstellen
// weitere Konfigurationseigenschaften
});

return () => {
todo.destructor(); // To-Do-Liste zerstören
toolbar.destructor(); // Toolbar zerstören
};
}, []);

return <div className="component_container">
<div ref={toolbar_container}></div>
<div ref={todo_container} className="widget"></div>
</div>
}

Styles hinzufügen

Richten Sie Styles ein, damit die To-Do-Liste korrekt dargestellt wird. Verwenden Sie die Datei index.css, um Styles für die To-Do-Liste und ihre Container festzulegen. Das folgende Beispiel definiert Layout-Abmessungen für die Seite:

index.css
/* Styles für die Ausgangsseite */
html,
body,
#root {
height: 100%;
padding: 0;
margin: 0;
background-color: #f7f7f7;
}

/* Styles für den To-Do-List- und Toolbar-Container */
.component_container {
height: 100%;
max-width: 800px;
margin: 0 auto;
}

/* Styles für den To-Do-List-Container */
.widget {
height: calc(100% - 56px);
}

Daten laden

Erstellen Sie die Datei data.js im Verzeichnis src/ und fügen Sie Daten hinzu. Das folgende Beispiel exportiert eine getData()-Funktion, die Aufgaben, Benutzer und Projekte zurückgibt:

data.js
export function getData() {
const tasks = [
{
id: "temp://1652991560212",
project: "introduction",
text: "Greetings, everyone! \u{1F44B} \nI'm DHTMLX To Do List.",
priority: 1
},
{
id: "1652374122964",
project: "introduction",
text: "You can assign task performers and due dates using the menu.",
assigned: ["user_4", "user_1", "user_2", "user_3"],
due_date: "2033-03-08T21:00:00.000Z",
priority: 2
},
// ...
];
const users = [
{
id: "user_1",
label: "Don Smith",
avatar:
"https://snippet.dhtmlx.com/codebase/data/common/img/02/avatar_61.jpg"
},
// ...
];
const projects = [
{
id: "introduction",
label: "Introduction to DHTMLX To Do List"
},
{
id: "widgets",
label: "Our widgets"
}
];
return { tasks, users, projects };
}

Öffnen Sie App.js und importieren Sie die Daten. Übergeben Sie die Daten als Props an die <ToDo/>-Komponente, wie unten gezeigt:

App.js
import ToDo from "./ToDo";
import { getData } from "./data";

function App() {
const { tasks, users, projects } = getData();
return <ToDo tasks={tasks} users={users} projects={projects} />;
}

export default App;

Öffnen Sie ToDo.jsx und wenden Sie die übergebenen Props auf das Konfigurationsobjekt der To-Do-Liste an. Das folgende Snippet übergibt Benutzer-, Aufgaben- und Projektdaten über die Konfiguration:

ToDo.jsx
import { useEffect, useRef } from "react";
import { ToDo, Toolbar } from "@dhx/trial-todolist";
import "@dhx/trial-todolist/dist/todo.css";

export default function ToDoComponent(props) {
let todo_container = useRef();
let toolbar_container = useRef();

useEffect(() => {
const todo = new ToDo(todo_container.current, {
users: props.users,
tasks: props.tasks,
projects: props.projects,
// weitere Konfigurationseigenschaften
});

const toolbar = new Toolbar(toolbar_container.current, {
api: todo.api,
// weitere Konfigurationseigenschaften
});

return () => {
todo.destructor();
toolbar.destructor();
};
}, []);

return <div className="component_container">
<div ref={toolbar_container}></div>
<div ref={todo_container} className="widget"></div>
</div>
}

Sie können auch die Methode parse() innerhalb von useEffect() verwenden, um Daten in die To-Do-Liste zu laden. Das folgende Beispiel lädt Daten nach der Initialisierung mit parse():

ToDo.jsx
import { useEffect, useRef } from "react";
import { ToDo, Toolbar } from "@dhx/trial-todolist";
import "@dhx/trial-todolist/dist/todo.css";

export default function ToDoComponent(props) {
let todo_container = useRef();
let toolbar_container = useRef();

let tasks = props.tasks;
let users = props.users;
let projects = props.projects;

useEffect(() => {
const todo = new ToDo(todo_container.current, {});

const toolbar = new Toolbar(toolbar_container.current, {
api: todo.api,
// weitere Konfigurationseigenschaften
});

todo.parse({ tasks, users, projects });

return () => {
todo.destructor();
toolbar.destructor();
};
}, []);

return <div className="component_container">
<div ref={toolbar_container}></div>
<div ref={todo_container} className="widget"></div>
</div>
}

Jeder Aufruf von parse(data) ersetzt den aktuellen Datensatz.

Die Komponente rendert jetzt eine befüllte To-Do-Liste. Weitere verfügbare Eigenschaften finden Sie in der Konfigurationsübersicht.

Events verarbeiten

Abonnieren Sie Events, um auf Benutzeraktionen zu reagieren. Siehe die vollständige Event-Liste.

Öffnen Sie ToDo.jsx und vervollständigen Sie die Methode useEffect(). Das folgende Snippet registriert einen Handler für das add-task-Event:

ToDo.jsx
// ...
useEffect(() => {
const todo = new ToDo(todo_container.current, {});

todo.api.on("add-task", (obj) => {
console.log("A new task is added", obj);
});

return () => {
todo.destructor();
};
}, []);
// ...

Schritt 3. To-Do-Liste in die App einbinden

Um die Komponente in die App einzubinden, öffnen Sie App.js und ersetzen Sie den Standard-Code durch das folgende Snippet:

App.js
import ToDo from "./ToDo";
import { getData } from "./data";

function App() {
const { tasks, users, projects } = getData();
return <ToDo tasks={tasks} users={users} projects={projects} />;
}

export default App;

Starten Sie die App. Die To-Do-Liste wird mit Beispieldaten gerendert:

In einer React-Anwendung gerendertes DHTMLX To Do List mit Beispieldaten

Das vollständige Projekt finden Sie auf GitHub.

Integration mit Svelte
Machen Sie sich mit den grundlegenden Konzepten und Mustern von Svelte vertraut, bevor Sie diese Dokumentation lesen. Zur Auffrischung Ihres Wissens lesen Sie die Svelte-Dokumentation.
DHTMLX To Do List ist mit Svelte kompatibel. Die folgenden Beispiele zeigen, wie Sie beide zusammen verwenden. Ein vollständiges Projekt finden Sie im Beispiel auf GitHub.
Projekt erstellen
Erstellen Sie ein neues Svelte-Projekt und installieren Sie die Abhängigkeiten.
Erstellen Sie ein Svelte-Projekt auf eine von zwei Arten:
- Verwenden Sie SvelteKit
- Verwenden Sie Svelte mit Vite ohne SvelteKit
Das folgende Beispiel erstellt ein Svelte- und Vite-Projekt:
npm create vite@latest
Weitere Details finden Sie im zugehörigen Artikel.
Abhängigkeiten installieren
Benennen Sie das Projekt my-svelte-todo-app und wechseln Sie in das App-Verzeichnis:
cd my-svelte-todo-app
Installieren Sie die Abhängigkeiten und starten Sie den Entwicklungsserver mit einem Paketmanager.
Führen Sie folgende Befehle mit yarn aus:
yarn
yarn start
Führen Sie folgende Befehle mit npm aus:
npm install
npm run dev
Die App läuft unter einer Localhost-Adresse (z. B. http://localhost:3000).
To-Do-Liste erstellen
Stoppen Sie die App und installieren Sie das To-Do-List-Paket.
Schritt 1. Paket installieren
Laden Sie das To-Do-List-Testpaket herunter und folgen Sie den Anweisungen in der README-Datei. Die Testversion ist nur 30 Tage lang verfügbar.
Schritt 2. Komponente erstellen
Erstellen Sie eine Svelte-Komponente, um die To-Do-Liste mit der Toolbar in die Anwendung einzubinden. Fügen Sie im Verzeichnis src/ eine neue Datei namens ToDo.svelte hinzu.
Quelldateien importieren
Öffnen Sie ToDo.svelte und importieren Sie die Quelldateien der To-Do-Liste. Wählen Sie einen der beiden Importpfade:
- PRO-Version aus einem lokalen Ordner installiert - Import aus
dhx-todolist-package - Testversion - Import aus
@dhx/trial-todolist
Das folgende Beispiel importiert aus dem PRO-Paket:
<script>
import { ToDo, Toolbar } from 'dhx-todolist-package';
import 'dhx-todolist-package/dist/todo.css';
</script>
Je nach Paket können die Quelldateien minifiziert sein. Importieren Sie die CSS-Datei in diesem Fall als todo.min.css.
Das folgende Snippet importiert aus dem Testpaket:
<script>
import { ToDo, Toolbar } from '@dhx/trial-todolist';
import '@dhx/trial-todolist/dist/todo.css';
</script>
Dieses Tutorial verwendet die Testversion.
Container festlegen und To-Do-Liste mit Toolbar hinzufügen
Um die To-Do-Liste mit der Toolbar auf der Seite anzuzeigen, erstellen Sie Container für beide Komponenten und initialisieren Sie diese mit den Konstruktoren. Das folgende Beispiel bindet die Container und initialisiert die Komponenten innerhalb von onMount:
<script>
import { onMount, onDestroy } from "svelte";
import { ToDo, Toolbar } from "@dhx/trial-todolist";
import "@dhx/trial-todolist/dist/todo.css";
let toolbar_container, todo_container; // Container für To-Do-Liste und Toolbar initialisieren
let todo, toolbar;
onMount(() => {
// To-Do-List-Komponente initialisieren
todo = new ToDo(todo_container, {})
// Toolbar-Komponente initialisieren
toolbar = new Toolbar(toolbar_container, {
api: todo.api, // innere API der To-Do-Liste bereitstellen
// weitere Konfigurationseigenschaften
})
});
onDestroy(() => {
todo.destructor(); // To-Do-Liste zerstören
toolbar.destructor(); // Toolbar zerstören
});
</script>
<div class="component_container">
<div bind:this={toolbar_container}></div>
<div bind:this={todo_container} style="height: calc(100% - 56px);"></div>
</div>
Daten laden
Erstellen Sie die Datei data.js im Verzeichnis src/ und fügen Sie Daten hinzu. Das folgende Beispiel exportiert eine getData()-Funktion, die Aufgaben, Benutzer und Projekte zurückgibt:
export function getData() {
const tasks = [
{
id: "temp://1652991560212",
project: "introduction",
text: "Greetings, everyone! \u{1F44B} \nI'm DHTMLX To Do List.",
priority: 1
},
{
id: "1652374122964",
project: "introduction",
text: "You can assign task performers and due dates using the menu.",
assigned: ["user_4", "user_1", "user_2", "user_3"],
due_date: "2033-03-08T21:00:00.000Z",
priority: 2
},
// ...
];
const users = [
{
id: "user_1",
label: "Don Smith",
avatar:
"https://snippet.dhtmlx.com/codebase/data/common/img/02/avatar_61.jpg"
},
// ...
];
const projects = [
{
id: "introduction",
label: "Introduction to DHTMLX To Do List"
},
{
id: "widgets",
label: "Our widgets"
}
];
return { tasks, users, projects };
}
Öffnen Sie App.svelte, importieren Sie die Daten und übergeben Sie diese als Props an die <ToDo/>-Komponente:
<script>
import ToDo from "./ToDo.svelte";
import { getData } from "./data.js";
const { users, tasks, projects } = getData();
</script>
<ToDo {users} {tasks} {projects} />
Öffnen Sie ToDo.svelte und wenden Sie die übergebenen Props auf das Konfigurationsobjekt der To-Do-Liste an. Das folgende Snippet übergibt Benutzer-, Aufgaben- und Projektdaten über die Konfiguration:
<script>
import { onMount, onDestroy } from "svelte";
import { ToDo, Toolbar } from "@dhx/trial-todolist";
import "@dhx/trial-todolist/dist/todo.css";
export let users;
export let tasks;
export let projects;
let toolbar_container, todo_container;
let todo, toolbar;
onMount(() => {
todo = new ToDo(todo_container, {
users,
tasks,
projects,
// weitere Konfigurationseigenschaften
})
toolbar = new Toolbar(toolbar_container, {
api: todo.api,
// weitere Konfigurationseigenschaften
})
});
onDestroy(() => {
todo.destructor();
toolbar.destructor();
});
</script>
<div class="component_container">
<div bind:this={toolbar_container}></div>
<div bind:this={todo_container} style="height: calc(100% - 56px);"></div>
</div>
Sie können auch die Methode parse() innerhalb von onMount() verwenden, um Daten in die To-Do-Liste zu laden. Das folgende Beispiel lädt Daten nach der Initialisierung mit parse():
<script>
import { onMount, onDestroy } from "svelte";
import { ToDo, Toolbar } from "@dhx/trial-todolist";
import "@dhx/trial-todolist/dist/todo.css";
export let users;
export let tasks;
export let projects;
let toolbar_container, todo_container;
let todo, toolbar;
onMount(() => {
todo = new ToDo(todo_container, {})
toolbar = new Toolbar(toolbar_container, {
api: todo.api,
// weitere Konfigurationseigenschaften
})
todo.parse({ tasks, users, projects });
});
onDestroy(() => {
todo.destructor();
toolbar.destructor();
});
</script>
<div class="component_container">
<div bind:this={toolbar_container}></div>
<div bind:this={todo_container} style="height: calc(100% - 56px);"></div>
</div>
Jeder Aufruf von parse(data) ersetzt den aktuellen Datensatz.
Die Komponente rendert jetzt eine befüllte To-Do-Liste. Weitere verfügbare Eigenschaften finden Sie in der Konfigurationsübersicht.
Events verarbeiten
Abonnieren Sie Events, um auf Benutzeraktionen zu reagieren. Siehe die vollständige Event-Liste.
Öffnen Sie ToDo.svelte und vervollständigen Sie die Methode onMount(). Das folgende Snippet registriert einen Handler für das add-task-Event:
<script>
// ...
let todo;
onMount(() => {
todo = new ToDo(todo_container, {});
todo.api.on("add-task", (obj) => {
console.log("A new task is added", obj);
});
});
onDestroy(() => {
todo.destructor();
});
</script>
// ...
Schritt 3. To-Do-Liste in die App einbinden
Um die Komponente in die App einzubinden, öffnen Sie App.svelte und ersetzen Sie den Standard-Code durch das folgende Snippet:
<script>
import ToDo from "./ToDo.svelte";
import { getData } from "./data.js";
const { users, tasks, projects } = getData();
</script>
<ToDo {users} {tasks} {projects} />
Starten Sie die App. Die To-Do-Liste wird mit Beispieldaten gerendert:

Das vollständige Projekt finden Sie auf GitHub.